.include "tn13def.inc"
.include "drive.inc"


/* 0 -  ; 1 -   ()
*/
			.DSEG
M1:	.byte 1	; 
KN1:	.byte 1	;   1
KN2:	.byte 1	;   2
			
			.CSEG
			.org 00
			rjmp start
			.org 02
			rjmp _INT
;__________________________________________________________________
; ...................................
start:	ldi zl,low(sram_start) 
            	ldi zh,high(sram_start)
Flush:      	clr r25
            	st  z+,r25
            	cpi zh,high(ramend+1)
            	brne    Flush 
            
            	cpi zl,low(ramend+1)
            	brne    Flush
            
            	clr zl
            	clr zh
            	; 
            	ldi zl,30
            	clr zh
            	dec zl
            	st z,zh
            	brne pc-2
; .............................
	ldi r16,low(ramend)
	out spl,r16
; .........................................
	ldi r16,3
	out portb,r16	;  0-1  
; .....................................
	ldi r16, 1<<pcie	
	out gimsk, r16	;  PCINT
	ldi r16, 1<<ISC00	
	out mcucr, r16	; PCINT   
	ldi r16, 1<<PCINT1
	out pcmsk,r16	;PCINT -   PB1
cli	;  
main:
	clr r25	;  
	Press pinb,0,KN1
	FP M1, 0	;  
	_call IE	;  
//	sbis pinb,0
//	cli	;     =0

mm:
rjmp main

;Function=====================================================================================
;   ...........................................
delay:
	ldi r16, 255	;   -   
	ldi r17, 0
decr:	subi r16, 1
	sbci r17, 0
	brcc decr
ret
;  ...........................................
IE:
	rcall delay
	ser r16
	out GIFR, r16	;  
	sei
ret
; .........................................................
_up:
	cbi portb, 3 	;        0
	sbi ddrb, 3	;   
	ldi r16, 255	;  170 ms
	ldi r17, 7
	subi r16,1
	sbci r17,0
	brcc pc-2
	cbi ddrb, 3	;  ,     
pop zh
pop zl
ijmp
; ..........................................................
_down:	cbi portb, 4	;0 -    
	sbi ddrb, 4	; ,   (   )
	ldi r16, 255	;
	ldi r17, 7
	subi r16, 1
	sbci r17, 0
	brcc pc-2
	cbi ddrb, 4	; ,     Z
pop zh
pop zl
ijmp
;Interrupt=====================================================================================
_INT:
	rcall delay	;  

	sbic pinb,1	;  ,    
	rjmp _up	;  
	sbis pinb,1	; ,   
	rjmp _down	;  


ret 
